##
# EPITECH PROJECT, 2024
# display_tty
# File description:
# constants.py
##

ERR = 1
ERROR = ERR
SUCCESS = 0

OUT_TTY = "tty"
OUT_STRING = "string"
OUT_FILE = "file"
OUT_DEFAULT = ''

# OUTPUT modes
KEY_OUTPUT_MODE = "OUTPUT_MODE"
KEY_PRETTIFY_OUTPUT = "PRETTIFY_OUTPUT"
KEY_PRETTIFY_OUTPUT_IN_BLOCKS = "PRETTY_OUTPUT_IN_BLOCS"

# Animation delays
KEY_ANIMATION_DELAY = 'MESSAGE_ANIMATION_DELAY'
KEY_ANIMATION_DELAY_BLOCKY = 'MESSAGE_ANIMATION_DELAY_BLOCKY'

TOML_CONF = {
    KEY_OUTPUT_MODE: OUT_TTY,
    KEY_PRETTIFY_OUTPUT: True,
    KEY_PRETTIFY_OUTPUT_IN_BLOCKS: True,
    KEY_ANIMATION_DELAY: 0.01,
    KEY_ANIMATION_DELAY_BLOCKY: 0.01,
    'MESSAGE_CHARACTER': '@',
    'MESSAGE_ERROR_CHARACTER': '#',
    'MESSAGE_INFORM_CHARACTER': 'i',
    'MESSAGE_QUESTION_CHARACTER': '?',
    'MESSAGE_SUCCESS_CHARACTER': '/',
    'MESSAGE_WARNING_CHARACTER': '!',
    'SUB_SUB_TITLE_WALL_CHARACTER': '*',
    'SUB_TITLE_WALL_CHARACTER': '@',
    'TITLE_WALL_CHARACTER': '#',
    'TREE_COLUMN_SEPERATOR_CHAR': '│',
    'TREE_LINE_SEPERATOR_CHAR': '─',
    'TREE_NODE_CHAR': '├',
    'TREE_NODE_END_CHAR': '└',
    'BOX_NO_VERTICAL': '#',
    'BOX_VERTICAL_NO_HORIZONTAL': '#',
    'ROUND_BOX_CORNER_LEFT': '╔',
    'ROUND_BOX_CORNER_RIGHT': '╗',
    'ROUND_BOX_CORNER_BOTTOM_LEFT': '╚',
    'ROUND_BOX_CORNER_BOTTOM_RIGHT': '╝',
    'ROUND_BOX_HORIZONTAL': '═',
    'ROUND_BOX_VERTICAL': '║',
    'DIFF_BORDER_LINE_CHARACTER_BOX': '-',
    'DIFF_SIDE_LINE_CHARACTER_BOX': '|',
}

# Numbers that can't be used for logging
FORBIDDEN_NUMBER_LOG_LEVELS_CORRESPONDANCE = {
    "INFO": 20,
    "WARN": 30,
    "DEBUG": 10,
    "FATAL": 50,
    "ERROR": 40,
    "NOTSET": 0,
    "WARNING": 40,
    "CRITICAL": 50
}

FORBIDDEN_NUMBER_LOG_LEVELS = list(
    FORBIDDEN_NUMBER_LOG_LEVELS_CORRESPONDANCE.values()
)
